#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum CheckAlertStatus {
    #[serde(rename = "PENDING_REVIEW")]
    PendingReview,
    #[serde(rename = "CLOSED_IGNORED")]
    ClosedIgnored,
    #[serde(rename = "CLOSED_REQUIRES_FURTHER_ACTION")]
    ClosedRequiresFurtherAction,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl CheckAlertStatus {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            CheckAlertStatus::PendingReview => "PENDING_REVIEW",
            CheckAlertStatus::ClosedIgnored => "CLOSED_IGNORED",
            CheckAlertStatus::ClosedRequiresFurtherAction => {
                "CLOSED_REQUIRES_FURTHER_ACTION"
            }
            CheckAlertStatus::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for CheckAlertStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for CheckAlertStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for CheckAlertStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<CheckAlertStatus, conjure_object::plain::ParseEnumError> {
        match v {
            "PENDING_REVIEW" => Ok(CheckAlertStatus::PendingReview),
            "CLOSED_IGNORED" => Ok(CheckAlertStatus::ClosedIgnored),
            "CLOSED_REQUIRES_FURTHER_ACTION" => {
                Ok(CheckAlertStatus::ClosedRequiresFurtherAction)
            }
            v => v.parse().map(|v| CheckAlertStatus::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for CheckAlertStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<CheckAlertStatus, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the CheckAlertStatus enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
